﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Infragistics45.Web.v20.1, Version=20.1.20201.4, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics45.Web.v20.1, Version=20.1.20201.4, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics45.Web.v20.1, Version=20.1.20201.4, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI" TagPrefix="ig" %>
<%--<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2294, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2294, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2294, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI" TagPrefix="ig" %>--%>


<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script>

        function WebDataGrid1_ExitedEditMode(sender, e) {
            addrow();
        }
        function addrow() {
            var grid = $find("WebDataGrid1");
            var row = new Array(grid.get_rows().get_length(), "");
            grid.get_rows().add(row);
        }

        function WebDataGrid1_Grid_AJAXResponse(sender, eventArgs) {
            var grid = $find("WebDataGrid1");
            const rows = grid.get_rows();
            const rowslength = rows.get_length();
         
            var currRow = grid.get_rows().get_row(grid.get_rows().get_length() - 1);
            const rowHeight = currRow._element.offsetHeight;
            const gridHeight = grid._container.style.height.slice(0, -2);
          
            var cell = currRow.get_cell(1);

            const coef = ((gridHeight / rowHeight) >> 0) - 1;
            if (gridHeight - rowslength * rowHeight < 0) {
                cell.scrollToView();
                grid._vScrBar.scrollTop = (currRow.get_index() - coef) * rowHeight;
            }
           
            grid.get_behaviors().get_editingCore().get_behaviors().get_cellEditing().enterEditMode(cell);
        }

        function WebDataGrid1_CellEditing_EnteredEditMode(sender, eventArgs) {
            var grid = $find("WebDataGrid1");
            const rows = grid.get_rows();
            const rowslength = rows.get_length();            
            var currRow = grid.get_rows().get_row(grid.get_rows().get_length() - 1);

            const rowHeight = currRow._element.offsetHeight;
            const gridHeight = grid._container.style.height.slice(0, -2);

            var cell = currRow.get_cell(1);

            // NOTE: get the same value as the one that is console logged and set it to line 70
           // console.log(eventArgs.getEditor().parentElement.style.marginTop);

            const coef = ((gridHeight / rowHeight) >> 0) - 1;
            if (eventArgs.getEditor().style.height === "5px") {
                cell.scrollToView();
                grid._vScrBar.scrollTop = (currRow.get_index() - coef) * rowHeight;
                eventArgs.getEditor().style.height = "27px";             
                eventArgs.getEditor().parentElement.style.marginTop = "284px";
            }
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
        
        <div>
            <ig:WebScriptManager ID="WebScriptManager1" runat="server"></ig:WebScriptManager>
           
            <ig:WebDataGrid ID="WebDataGrid1" runat="server" Height="350px" Width="400px" DataKeyFields="Id" EnableDataViewState="True" >
                <ClientEvents AJAXResponse="WebDataGrid1_Grid_AJAXResponse" />
                <Behaviors>
                    <ig:Activation></ig:Activation>
                    <ig:EditingCore>
                        <Behaviors>
                            <ig:CellEditing>
                                <CellEditingClientEvents
                                    ExitedEditMode="WebDataGrid1_ExitedEditMode"
                                    EnteredEditMode="WebDataGrid1_CellEditing_EnteredEditMode">
                                </CellEditingClientEvents>
                            </ig:CellEditing>                           
                        </Behaviors>
                    </ig:EditingCore>
                    <ig:Selection CellClickAction="Row"></ig:Selection>
                </Behaviors>
            </ig:WebDataGrid>
            
        </div>
    </form>
</body>
</html>
